<?php

	/**
	 * Dieses Modul erlaubt die Zahlungsart "Kreditkarte"
	 * @author hartmut 
	 */
	class wpsg_mod_creditcard extends wpsg_mod_basic
	{
		
		var $lizenz = 2;
		var $id = 16;
		var $version = "4.1.8.7645";
		var $hilfeURL = 'http://wpshopgermany.de/?p=4634999';
		
		/**
		 * Costructor
		 */
		public function __construct()
		{
			
			parent::__construct();
			
			$this->name = __('Kreditkarte', 'wpsg');
			$this->group = __('Zahlungsarten', 'wpsg');
			$this->desc = __('Ermöglicht die Zahlungsart Kreditkarte.', 'wpsg');
						
		} // public function __construct()
		
		public function install()
		{
			 
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
			
			/**
			 * Bestelltabelle erweitern
			 */ 
			$sql = "CREATE TABLE ".WPSG_TBL_ORDER." (
		   		mod_creditcard_typ VARCHAR(255) NOT NULL,
		   		mod_creditcard_inhaber VARCHAR(255) NOT NULL,
		   		mod_creditcard_knr VARCHAR(255) NOT NULL,
		   		mod_creditcard_pruefz VARCHAR(255) NOT NULL,
		   		mod_creditcard_gueltigm VARCHAR(255) NOT NULL,
				mod_creditcard_gueltigj VARCHAR(255) NOT NULL
		   	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
   	   	 
   			dbDelta($sql);
   			
   			$this->shop->checkDefault('wpsg_mod_creditcard_bezeichnung', $this->name, false, true);
   			$this->shop->checkDefault('wpsg_mod_creditcard_aktiv', '1');
   			$this->shop->checkDefault('wpsg_mod_creditcard_hint', __('Wählen Sie diese Zahlungsart wenn sie uns eine Einzugsermächtigung für ihr Konto erteilen möchten. Wir benötigen dazu folgende Angaben:', 'wpsg'), false, true);
   			$this->shop->checkDefault('wpsg_mod_creditcard_gebuehr', '0');
   			$this->shop->checkDefault('wpsg_mod_creditcard_mwst', '0');
   			$this->shop->checkDefault('wpsg_mod_creditcard_mwstland', '0');
			
		} // public function install()
		
		public function settings_edit()
		{
									
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_creditcard/settings_edit.phtml');
			
		}
		
		public function settings_save()
		{
			
		    $this->shop->update_option('wpsg_mod_creditcard_bezeichnung', $_REQUEST['wpsg_mod_creditcard_bezeichnung'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_creditcard_aktiv', $_REQUEST['wpsg_mod_creditcard_aktiv'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_creditcard_hint', $_REQUEST['wpsg_mod_creditcard_hint'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_creditcard_gebuehr', $_REQUEST['wpsg_mod_creditcard_gebuehr'], false, false, WPSG_SANITIZE_FLOAT);
			$this->shop->update_option('wpsg_mod_creditcard_mwst', $_REQUEST['wpsg_mod_creditcard_mwst'], false, false, WPSG_SANITIZE_TAXKEY);
			$this->shop->update_option('wpsg_mod_creditcard_mwstland', $_REQUEST['wpsg_mod_creditcard_mwstland'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_creditcard_schluessel', $_REQUEST['wpsg_mod_creditcard_schluessel'], false, false, WPSG_SANITIZE_TEXTFIELD);
				
		} // public function settings_save()
	
		public function addPayment(&$arPayment) { 
			 
			if (is_admin() || $this->shop->get_option('wpsg_mod_creditcard_aktiv') == '1') {
				
				$this->shop->view['wpsg_mod_creditcard'] = [
					'typ' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_typ']),
					'inhaber' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_inhaber']),
					'knr' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_knr']),
					'pruefz' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_pruefz']),
					'gueltigm' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_gueltigm']),
					'gueltigj' => wpsg_getStr($_SESSION['wpsg']['checkout']['mod_creditcard_gueltigj'])
				];
				 
				$arPayment[$this->id] = array(
					'id' => $this->id,
					'name' => __($this->shop->get_option('wpsg_mod_creditcard_bezeichnung'), 'wpsg'),
					'price' => $this->shop->get_option('wpsg_mod_creditcard_gebuehr'),
					'tax_key' => $this->shop->get_option('wpsg_mod_creditcard_mwst'),
					'mwst_null' => $this->shop->get_option('wpsg_mod_creditcard_mwstland'),
					//'hint' => __($this->shop->get_option('wpsg_mod_creditcard_hint')),
					'hint' => $this->shop->render(WPSG_PATH_VIEW.'mods/mod_creditcard/paymenthint.phtml', false),
					'logo' => $this->shop->getRessourceURL('mods/mod_creditcard/gfx/logo_100x25.png')
				);
							
			}
			
		} // public function addPayment(&$arPayment)
			
		public function checkCheckout(&$state, &$error, &$arCheckout)  { 

			if(wpsg_isSizedString($arCheckout['payment'])) {

				if ($arCheckout['payment'] != $this->id) return;
				
			}
	 
			// Werte in die Session und den Checkout schreiben schreiben
			if (
					(isset($_REQUEST['wpsg_checkout']) && wpsg_isSizedArray($_REQUEST['wpsg_mod_creditcard'])) || 
					(isset($_REQUEST['wpsg_checkout2']) && wpsg_isSizedArray($_REQUEST['wpsg_mod_creditcard']))
			)
			{
		 
				$_SESSION['wpsg']['checkout']['mod_creditcard_typ'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['typ']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_pruefz'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['pruefz']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_gueltigm'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['gueltigm']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_gueltigj'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['gueltigj']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_inhaber'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['inhaber']);
				$_SESSION['wpsg']['checkout']['mod_creditcard_knr'] = wpsg_xss($_REQUEST['wpsg_mod_creditcard']['knr']);
				
				$arCheckout['mod_creditcard_typ'] = $_SESSION['wpsg']['checkout']['mod_creditcard_typ'];
				$arCheckout['mod_creditcard_pruefz'] = $_SESSION['wpsg']['checkout']['mod_creditcard_pruefz'];
				$arCheckout['mod_creditcard_gueltigm'] = $_SESSION['wpsg']['checkout']['mod_creditcard_gueltigm'];
				$arCheckout['mod_creditcard_gueltigj'] = $_SESSION['wpsg']['checkout']['mod_creditcard_gueltigj'];
				$arCheckout['mod_creditcard_inhaber'] = $_SESSION['wpsg']['checkout']['mod_creditcard_inhaber'];
				$arCheckout['mod_creditcard_knr'] = $_SESSION['wpsg']['checkout']['mod_creditcard_knr'];

			}

			if ( 
					(($state > 1) ||
					($state >= 1 && $this->shop->hasMod('wpsg_mod_onepagecheckout'))) &&
					(isset($_REQUEST['wpsg_checkout']) || isset($_REQUEST['wpsg_checkout2']))
				)
			{
						
				if (trim($arCheckout['mod_creditcard_typ']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_typ'; $this->shop->addFrontendError(__('Bitte den Namen der Kreditkarte kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				if (trim($arCheckout['mod_creditcard_inhaber']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_inhaber'; $this->shop->addFrontendError(__('Bitte den Inhaber des Kontos kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				

				if (trim($arCheckout['mod_creditcard_pruefz']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_pruefz'; $this->shop->addFrontendError(__('Bitte die Prüfziffer kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				if (trim($arCheckout['mod_creditcard_knr']) == '') { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_knr'; $this->shop->addFrontendError(__('Bitte die Kartennummer überprüfen (Kreditkarte)', 'wpsg')); $error = true; }
				
				if (strlen(trim($arCheckout['mod_creditcard_pruefz'])) != 3) { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_pruefz'; $this->shop->addFrontendError(__('Bitte die Prüfziffer kontrollieren (Kreditkarte)', 'wpsg')); $error = true; }
				
				// Kartennummer prüfen
				$typ = trim($arCheckout['mod_creditcard_typ']);
				$knr = trim($arCheckout['mod_creditcard_knr']);

				if ($this->checkCreditCardNumber($typ, $knr) == false) { $_SESSION['wpsg']['errorFields'][] = 'mod_creditcard_knr'; $this->shop->addFrontendError(__('Bitte die Kartennummer überprüfen (Kreditkarte)', 'wpsg')); $error = true; }
				//checkCreditCardNumber($typ, $knr);
 						
			}
			
		} // public function checkCheckout(&$state, &$error, &$arCheckout)
		
		private function checkCreditCardNumber($typ, $knr)
		{
			$knr = str_replace(" ", "", $knr);
			$bb = true;
			
			if (!is_int($knr) == false)
			{
				return false;
			}
			$a1 = substr($knr, 0, 1);
			$ai = intval(substr($knr, 15, 1), 10);
			if (!((($a1 == "4") && ($typ == "VISA")) || (($a1 == "5") && ($typ == "MasterCard"))))
			{
				$bb = false;
			}
			$sum = 0;
			$k = 2;
			for ($i = 14; $i >= 0; $i--) {
				$dig = $k * intval(substr($knr, $i, 1), 10);
				if ($dig > 9) { $dig = $dig - 9;}
				$sum = $sum + $dig;
				//$sum = $sum + $k * intval(substr($knr, $i, 1), 10);
				if ($k == 2) { $k = 1; } else { $k = 2; }
			}
			$sum = $sum % 10;
			if ($sum > 0) { $sum = 10 - $sum; }
			if ($sum != $ai) { $bb = false; }
			
			return $bb;	
			
		}
		
		public function calculation_saveOrder(&$oCalculation, $arCalculation, &$db_data, $finish_order) { 
			
			if ($_SESSION['wpsg']['checkout']['payment'] == $this->id) {
				
				$checkout = $_SESSION['wpsg']['checkout'];
				
				// Daten in die Bestelltabelle hinzutragen
				
				//AES256
				//string mcrypt_encrypt ( string $cipher , string $key , string $data , string $mode [, string $iv ] )
				$key = $this->shop->get_option("wpsg_mod_creditcard_schluessel");
				$iv = mcrypt_create_iv(16, MCRYPT_RAND);
				
				//echo wpsg_q($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_typ'], MCRYPT_MODE_CBC, $iv));
				
				$db_data['mod_creditcard_typ'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_typ'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_pruefz'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_pruefz'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_gueltigm'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_gueltigm'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_gueltigj'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_gueltigj'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_inhaber'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_inhaber'], MCRYPT_MODE_CBC, $iv));
				$db_data['mod_creditcard_knr'] = base64_encode($iv.mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_knr'], MCRYPT_MODE_CBC, $iv));
								
			}
						
		}
		 
		public function order_view_afterpayment(&$order_id) 
		{ 
									
			$order_data = $this->shop->cache->loadOrder($order_id);
			
			if ($order_data['type_payment'] != $this->id) return;
			
			$this->shop->view['wpsg_mod_creditcard']['typ'] = $order_data['mod_creditcard_typ'];
			$this->shop->view['wpsg_mod_creditcard']['pruefz'] = $order_data['mod_creditcard_pruefz'];
			$this->shop->view['wpsg_mod_creditcard']['gueltigm'] = $order_data['mod_creditcard_gueltigm'];
			$this->shop->view['wpsg_mod_creditcard']['gueltigj'] = $order_data['mod_creditcard_gueltigj'];
				$this->shop->view['wpsg_mod_creditcard']['inhaber'] = $order_data['mod_creditcard_inhaber'];
			$this->shop->view['wpsg_mod_creditcard']['knr'] = $order_data['mod_creditcard_knr'];
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_creditcard/order_view_afterpayment.phtml');
			
		} // public function order_view_afterpayment(&$order_id)
		
		public function make_iban($blz, $kontonr, $land_kuerzel) 
		{
			
  			$blz8 = str_pad ( $blz, 8, "0", STR_PAD_RIGHT);
  			$kontonr10 = str_pad ( $kontonr, 10, "0", STR_PAD_LEFT);
  			$bban = $blz8 . $kontonr10;
  			$pruefsumme = $bban."131400";
  			$modulo = (bcmod($pruefsumme,"97"));
  			$pruefziffer =str_pad ( 98 - $modulo, 2, "0",STR_PAD_LEFT);
  			$iban = $land_kuerzel.$pruefziffer.$bban;
  
  			return $iban;

		} // public function make_iban($blz, $kontonr) 
		
		public function test_iban($iban) 
		{
			
			$iban = str_replace(' ', '', $iban);
			$iban1 = substr($iban, 4).strval(ord($iban{0}) - 55).strval(ord($iban{1}) - 55). substr($iban, 2, 2);
		
			for ($i = 0; $i < strlen($iban1); $i++) 
			{
				
				if(ord($iban1{$i}) > 64 && ord($iban1{$i}) < 91) 
				{
					
					$iban1 = substr($iban1, 0, $i).strval(ord($iban1{$i}) - 55).substr($iban1, $i + 1);
					
				}
				
			}
			
			$rest = 0;
			
			for ($pos=0; $pos < strlen($iban1); $pos += 7) 
			{
				
				$part = strval($rest).substr($iban1, $pos, 7);
				$rest = intval($part) % 97;
				
			}
			
			$pz = sprintf("%02d", 98-$rest);
		
			if (substr($iban, 2, 2) == '00')
			{
			
				return substr_replace($iban, $pz, 2, 2);
				
			} 
			else 
			{
			
				return ($rest == 1)?true:false;
				
			}
		
		} // public function test_iban( $iban )

		/**
		 * Export der Daten als CSV
		 * {@inheritDoc}
		 * @see wpsg_mod_basic::wpsg_mod_export_loadFields()
		 */
		public function wpsg_mod_export_loadFields(&$arFields)
		{
			/*
		   		mod_creditcard_typ VARCHAR(255) NOT NULL,
		   		mod_creditcard_inhaber VARCHAR(255) NOT NULL,
		   		mod_creditcard_knr VARCHAR(255) NOT NULL,
		   		mod_creditcard_pruefz VARCHAR(255) NOT NULL,
		   		mod_creditcard_gueltigm VARCHAR(255) NOT NULL,
				mod_creditcard_gueltigj VARCHAR(255) NOT NULL
			 */	
			$arFields[10]['fields']['mod_creditcard_typ'] = __('Kreditkartentyp', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_inhaber'] = __('Kreditkarteninhaber', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_knr'] = __('Kreditkartennummer', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_pruefz'] = __('Kreditkartenprüfziffer', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_gueltigm'] = __('Kreditkarten-Gültigkeit-Monat', 'wpsg');
			$arFields[10]['fields']['mod_creditcard_gueltigj'] = __('Kreditkarten-Gültigkeit-Jahr', 'wpsg');
				
		} // public function wpsg_mod_export_loadFields(&$arFields)
		
		public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $productkey, $product_index, $profil_separator)
		{
			$arOrder = $this->shop->cache->loadOrder($o_id);
			$value = "";
			
			if ($field_value == 'mod_creditcard_typ')
			{
				$value = $arOrder['mod_creditcard_typ'];
			}
			if ($field_value == 'mod_creditcard_inhaber')
			{
				$value = $arOrder['mod_creditcard_inhaber'];
			}
			if ($field_value == 'mod_creditcard_knr')
			{
				$value = $arOrder['mod_creditcard_knr'];
			}
			if ($field_value == 'mod_creditcard_pruefz')
			{
				$value = $arOrder['mod_creditcard_pruefz'];
			}
			if ($field_value == 'mod_creditcard_gueltigm')
			{
				$value = $arOrder['mod_creditcard_gueltigm'];
			}
			if ($field_value == 'mod_creditcard_gueltigj')
			{
				$value = $arOrder['mod_creditcard_gueltigj'];
			}
			
			if ($value == "")
			{
				$return = $value;
			}
			else 
			{
				// Test
				/*
				$val = base64_decode($value);
				$ll = strlen($val);
				$iv = substr($val, 0, 16);
				$ll = strlen($iv);
				$key = $this->shop->get_option("wpsg_mod_creditcard_schluessel");
				$dec1 = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, "VISAVISAVISAVISA", MCRYPT_MODE_CBC, $iv);
				$ll = strlen($dec1);
				$dec1 = $iv.$dec1;
				$ll = strlen($dec1);
				$dec2 = base64_encode($dec1);
				$ll = strlen($dec2);
				$dec3 = base64_decode($dec2);
				$ll = strlen($dec3);
				$dec3 = substr($dec3, 16);
				$dec4 = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $key, $dec3, MCRYPT_MODE_CBC, $iv);
				$dec5 = trim($dec4, " \t\n\r\0\x0B");
				*/
				$key = $this->shop->get_option("wpsg_mod_creditcard_schluessel");
				//$iv = mcrypt_create_iv(16, MCRYPT_RAND);
			
				//$value = base64_decode($value);
				//$iv = substr($value, 0, 16);
				//$value = substr($value, 16);
				//echo wpsg_q(mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $checkout['mod_creditcard_typ'], MCRYPT_MODE_CBC, $iv));
				//$value = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $key, $value, MCRYPT_MODE_CBC, $iv);
				//$value = trim($value, " \t\n\r\0\x0B");
				$return = $value;
			}
		} // public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $productkey, $product_index, $profil_separator)
		
	} // class wpsg_mod_creditcard extends wpsg_mod_basic

?>